<?php


namespace App\Models;

use App\Entities\FormaPagamento\FormaPagamento;
use App\Services\FormaPagamentoService;
use App\Services\JWTService;
use App\Services\PessoaService;
use App\Services\Service;
use App\Utils\DateUtils;
use App\Utils\ModelUtils;
use App\ViewModels\FormaPagamento\FormaPagamentoRegistrationViewModel\FormaPagamentoRegistrationViewModel;
use CodeIgniter\Model;

class FormaPagamentoModel extends ModelEntity {
	protected $table = 'forma_pagamento';
	protected $primaryKey = 'id';
	protected $returnType = 'array';
	protected $allowedFields = [ 
			'descricao',
			'criado_em',
			'atualizado_em',
			'desativado_em',
			'criado_por',
			'alterado_por',
			'desativado_por'
	];
	protected $useSoftDeletes = false;
	protected $skipValidation = true;
	protected $useTimestamps = true;
	protected $createdField = 'criado_em';
	protected $updatedField = 'atualizado_em';

	public function registerFormaPagamento(FormaPagamento &$forma_pagamento): void {

		$forma_pagamento_data = $forma_pagamento->toArray();
		unset( $forma_pagamento_data ['id'] );
		unset( $forma_pagamento_data ['criado_em'] );
		unset( $forma_pagamento_data ['atualizado_em'] );
		$id_new_forma_pagamento = $this->insert( $forma_pagamento_data );
		$forma_pagamento->setId( $id_new_forma_pagamento );

	}

	public function updateFormaPagamentoByID(int $id_forma_pagamento, FormaPagamento $forma_pagamento): bool {

		$data = $forma_pagamento->toArray( true );
		if (count( $data ) > 0) {
			$binds = [ 
					'id_forma_pagamento' => $id_forma_pagamento
			];
			$sql = "UPDATE forma_pagamento ";
			$sql .= $this->generateUpdateSets( $data, $binds );
			$sql .= 'WHERE forma_pagamento.id = :id_forma_pagamento:';
			$query = $this->db->query( $sql, $binds );
			$errors = $this->errors();
			return !$errors;
		} else {
			return true;
		}

	}

	public function deleteFormaPagamentoByID(int $id_forma_pagamento): bool {

		$jwt_payload = JWTService::getTokenJWTPayload();
		$uid = $jwt_payload ? $jwt_payload->getUid() : null;
		$today = DateUtils::today();

		$binds = [ 
				'desativado_por' => $uid,
				'desativado_em' => $today,
				'id_forma_pagamento' => $id_forma_pagamento
		];
		$sql = "UPDATE forma_pagamento SET desativado_por = :desativado_por: , desativado_em = :desativado_em: WHERE forma_pagamento.id = :id_forma_pagamento:";
		$query = $this->db->query( $sql, $binds );

		$errors = $this->errors();
		return !$errors;

	}

}
